<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/actions');

// https://code.spip.net/@exec_mots_tous_dist
function exec_mots_tous_dist()
{
	global $spip_lang, $spip_lang_left, $spip_lang_right, $son_groupe, $conf_mot;

///////////////////
//MODIFICATION
///////////////////
// liste des types de tables sur lesquels on peut mettre des mots clés
// - ceux du core
//	$choses= array('articles', 'breves', 'rubriques', 'syndic');
// - ceux du plugin
//	include(_DIR_PLUGIN_MOTSPARTOUT."/mots_partout_choses.php");


  $tables_installees = unserialize(lire_meta('MotsPartout:tables_installees'));

	/* définition d'un pipeline qu'un autre plugin pourra appeler pour ajouter un type d'objet non spip a gerer dans mots partout */
  //$tables_installees = pipeline('motspartout_tables_installes',$tables_installees);
  //tester pour voir s'il faut écrire dans les metas

  if (!$tables_installees){
	  $tables_installees= array('articles','rubriques','documents','auteurs','syndic','syndic_articles','messages');
	  ecrire_meta('MotsPartout:tables_installees',serialize($tables_installees));
	}

	foreach($tables_installees as $chose => $m) { $choses[]= $chose; }
///////////////////

		$conf_mot = intval(_request('conf_mot'));
	$son_groupe = intval(_request('son_groupe'));

	pipeline('exec_init',array('args'=>array('exec'=>'mots_tous'),'data'=>''));
	$commencer_page = charger_fonction('commencer_page', 'inc');
	echo $commencer_page(_T('titre_page_mots_tous'), "naviguer", "mots");
	echo debut_gauche('', true);


	echo pipeline('affiche_gauche',array('args'=>array('exec'=>'mots_tous'),'data'=>''));

	if (autoriser('creer','groupemots')  AND !$conf_mot){
		$out = "";
		$result = sql_select("*, ".sql_multi ("titre", "$spip_lang"), "spip_groupes_mots", "", "", "multi");
		while ($row_groupes = sql_fetch($result)) {
			$id_groupe = $row_groupes['id_groupe'];
			$titre_groupe = typo($row_groupes['titre']);
			$out .= "<li><a href='#mots_tous-$id_groupe' onclick='$(\"div.mots_tous\").hide().filter(\"#mots_tous-$id_groupe\").show();return false;'>$titre_groupe</a></li>";
		}
		if (strlen($out))
			$out = "
			<ul class='raccourcis_rapides'>".$out."</ul>
			<a href='#' onclick='$(\"div.mots_tous\").show();return false;'>"._T('icone_voir_tous_mots_cles')."</a>";

		$res = icone_horizontale(_T('icone_creation_groupe_mots'), generer_url_ecrire("mots_type","new=oui"), "groupe-mot-24.gif", "creer.gif",false);
		echo bloc_des_raccourcis($res . $out);
	}


	echo creer_colonne_droite('', true);
	echo pipeline('affiche_droite',array('args'=>array('exec'=>'mots_tous'),'data'=>''));
	echo debut_droite('', true);

	echo gros_titre(_T('titre_mots_tous'),'', false);
	if (autoriser('creer','groupemots')) {
	  echo typo(_T('info_creation_mots_cles')) . aide ("mots") ;
	}
	echo "<br /><br />";

//
// On boucle d'abord sur les groupes de mots
//
	//Modif mots clef arbo
	//va afficher les groupes et leurs sous groupes de mots clefs
	mots_partout_arbo_affiche_sous_groupe();


	echo pipeline('affiche_milieu',array('args'=>array('exec'=>'mots_tous'),'data'=>''));
	echo fin_gauche(), fin_page();
}


//YOANN
// https://code.spip.net/@mots_partout_arbo_affiche_sous_groupe
function mots_partout_arbo_affiche_sous_groupe($id_groupe=0){
//cette fonction permet d'afficher recursivement les groupes et leurs sous groupes de mots clefs
    global $conf_mot, $spip_lang, $spip_lang_right, $son_groupe;
    $tables_installees = unserialize(lire_meta('MotsPartout:tables_installees'));
	  foreach($tables_installees as $chose) { $choses[]= $chose; }

    $result_groupes = sql_select("*, ".sql_multi ("titre", "$spip_lang"), "spip_groupes_mots", "id_parent=".$id_groupe, "","multi");

	while ($row_groupes = sql_fetch($result_groupes)) {
		$id_groupe = $row_groupes['id_groupe'];
		$id_parent= $row_groupes['id_parent'];
		$titre_groupe = typo($row_groupes['titre']);
		$descriptif = $row_groupes['descriptif'];
		$texte = $row_groupes['texte'];
		$unseul = $row_groupes['unseul'];
		$obligatoire = $row_groupes['obligatoire'];
		$tables_liees = $row_groupes['tables_liees'];
		$acces_minirezo = $row_groupes['minirezo'];
		$acces_comite = $row_groupes['comite'];
		$acces_forum = $row_groupes['forum'];
///////////////////
//MODIFICATION
///////////////////
/*
		$articles = $row_groupes['articles'];
		$breves = $row_groupes['breves'];
		$rubriques = $row_groupes['rubriques'];
		$syndic = $row_groupes['syndic'];
*/
///////////////////

		// Afficher le titre du groupe
		echo "<div id='mots_tous-$id_groupe' class='mots_tous'>";
		echo debut_cadre_enfonce("groupe-mot-24.gif", true, '', $titre_groupe);

		//YOANN
		//TODO Ajaxiser la partie ouverture et fermeture  ci dessous : car sur une grosse arborescence c'est assez lourd
		if($id_parent==0)
		{ //on n'aura que pour le premier niveau cette possibilité d'ouverture fermeture
  		echo "<a href=\"javascript:;\" onclick=\"$('#bloc-groupe-$id_groupe').toggle()\" >Ouvrir / Fermer</a>";
  		$aff="";
  		if(_request('id_groupe')!=$id_groupe) $aff="style='display:none;'";
  		echo "<div id='bloc-groupe-$id_groupe' class='mots_tous'' $aff >"; //YOANN fermer ouvrir
		}
		//FIN YOANN

		// Affichage des options du groupe (types d'elements, permissions...)
		$res = '';

///////////////////
//MODIFICATION
///////////////////
/*
		if ($articles == "oui") $res .= "> "._T('info_articles_2')." &nbsp;&nbsp;";
		if ($breves == "oui") $res .= "> "._T('info_breves_02')." &nbsp;&nbsp;";
		if ($rubriques == "oui") $res .= "> "._T('info_rubriques')." &nbsp;&nbsp;";
		if ($syndic == "oui") $res .= "> "._T('icone_sites_references')." &nbsp;&nbsp;";
*/
///////////////////
//MODIFICATION
///////////////////
//TODO : documenter syntaxe
// affichage des cases a cocher

		foreach($choses as $chose) {
			if ($row_groupes[$chose] == "oui") echo "> "._T('motspartout:info_'.$chose)." &nbsp;&nbsp;";
		}

		$tables_liees = explode(',',$tables_liees);

		$libelles = array('articles'=>'info_articles_2','breves'=>'info_breves_02','rubriques'=>'info_rubriques','syndic'=>'icone_sites_references');
		$libelles = pipeline('libelle_association_mots',$libelles);

		foreach($tables_liees as $table)
			if (strlen($table))
				$res .= "> " . _T(isset($libelles[$table])?$libelles[$table]:"$table:info_$table") . " &nbsp;&nbsp;";

///////////////////
		if ($unseul == "oui" OR $obligatoire == "oui") $res .= "<br />";
		if ($unseul == "oui") $res .= "> "._T('info_un_mot')." &nbsp;&nbsp;";
		if ($obligatoire == "oui") $res .= "> "._T('info_groupe_important')." &nbsp;&nbsp;";

		$res .= "<br />";
		if ($acces_minirezo == "oui") $res .= "> "._T('info_administrateurs')." &nbsp;&nbsp;";
		if ($acces_comite == "oui") $res .= "> "._T('info_redacteurs')." &nbsp;&nbsp;";
		if ($acces_forum == "oui") $res .= "> "._T('info_visiteurs_02')." &nbsp;&nbsp;";

 		echo "<span class='verdana1 spip_x-small'>", $res, "</span>";
		if (strlen($descriptif)) {
			echo "<div style='border: 1px dashed #aaaaaa;' class='verdana1 spip_small'>", "<b>",_T('info_descriptif'),"</b> ", propre($descriptif), "&nbsp; </div>";
		}

		if (strlen($texte)>0){
			echo "<div class='verdana1 spip_small'>", propre($texte), "</div>";
		}

		//
		// Afficher les mots-cles du groupe
		//

		$groupe = spip_fetch_array(spip_query("SELECT COUNT(*) AS n FROM spip_mots WHERE id_groupe=$id_groupe"));
		$groupe = $groupe['n'];

		echo "<div\nid='editer_mot-$id_groupe' style='position: relative;'>";

		// Preliminaire: confirmation de suppression d'un mot lie a qqch
		// (cf fin de afficher_groupe_mots_boucle executee a l'appel precedent)
		if ($conf_mot  AND $son_groupe==$id_groupe) {
			include_spip('inc/grouper_mots');
			echo confirmer_mot($conf_mot, $id_groupe, $groupe);
		}
		if ($groupe) {
		  	$grouper_mots = charger_fonction('grouper_mots', 'inc');
			echo $grouper_mots($id_groupe, $groupe);
		}

		echo "</div>";

		if (autoriser('modifier','groupemots',$id_groupe)){
			echo "\n<table cellpadding='0' cellspacing='0' border='0' width='100%'>";
			echo "<tr>";
			echo "<td>";
			echo icone_inline(_T('icone_modif_groupe_mots'), generer_url_ecrire("mots_type","id_groupe=$id_groupe"), "groupe-mot-24.gif", "edit.gif", $spip_lang_left);
			echo "</td>";
			echo "\n<td id='editer_mot-$id_groupe-supprimer'",
			  (!$groupe ? '' : " style='visibility: hidden'"),
			  ">";
			echo icone_inline(_T('icone_supprimer_groupe_mots'), redirige_action_auteur('instituer_groupe_mots', "-$id_groupe", "mots_tous"), "groupe-mot-24.gif", "supprimer.gif", $spip_lang_left);
			echo "</td>";

			// YOANN on permet d'ajouter un sous groupe a n'importe quel groupe
			echo "<td>";
			echo icone_inline(_T('motspartout:icone_creation_sous_groupe_mots'), generer_url_ecrire("mots_type","new=oui&id_parent=".$id_groupe), "groupe-mot-24.gif", "edit.gif");
			echo "</td>";
			//FIN YOANN

			echo "<td>";
			echo "<div align='$spip_lang_right'>";
			echo icone_inline(_T('icone_creation_mots_cles'), generer_url_ecrire("mots_edit","new=oui&id_groupe=$id_groupe&redirect=" . generer_url_retour('mots_tous', "#mots_tous-$id_groupe")), "mot-cle-24.gif", "creer.gif", $spip_lang_right);
			echo "</div>";
			echo "</td></tr></table>";
		}

		mots_partout_arbo_affiche_sous_groupe($id_groupe); //

		if($id_parent==0) echo "</div>"; //YOANN fin du div qui permet de fermer ouvrir un bloc

		echo fin_cadre_enfonce(true);
		echo "</div>";

	}


}
//FIN YOANN


// https://code.spip.net/@confirmer_mot
function confirmer_mot ($conf_mot, $son_groupe, $total)
{
	$row = spip_fetch_array(spip_query("SELECT * FROM spip_mots WHERE id_mot=$conf_mot"));
	if (!$row) return ""; // deja detruit (acces concurrent etc)

	$id_mot = $row['id_mot'];
	$titre_mot = typo($row['titre']);
	$type_mot = typo($row['type']);

///////////////////
//MODIFICATION
///////////////////
/*
	if (($na = intval(_request('na'))) == 1) {
		$texte_lie = _T('info_un_article')." ";
	} else if ($na > 1) {
		$texte_lie = _T('info_nombre_articles', array('nb_articles' => $na)) ." ";
	}
	if (($nb = intval(_request('nb'))) == 1) {
		$texte_lie .= _T('info_une_breve')." ";
	} else if ($nb > 1) {
		$texte_lie .= _T('info_nombre_breves', array('nb_breves' => $nb))." ";
	}
	if (($ns = intval(_request('ns'))) == 1) {
		$texte_lie .= _T('info_un_site')." ";
	} else if ($ns > 1) {
		$texte_lie .= _T('info_nombre_sites', array('nb_sites' => $ns))." ";
	}
	if (($nr = intval(_request('nr'))) == 1) {
		$texte_lie .= _T('info_une_rubrique')." ";
	} else if ($nr > 1) {
		$texte_lie .= _T('info_nombre_rubriques', array('nb_rubriques' => $nr))." ";
	}
*/
$tables_installees = unserialize(lire_meta('MotsPartout:tables_installees'));
	if (!$tables_installees){
	  $tables_installees=array("articles"=>true,"rubriques"=>true,"breves"=>true,"forum"=>true,"syndic"=>true);
	  ecrire_meta('MotsPartout:tables_installees',serialize($tables_installees));
	  ecrire_metas();
	}
	//TODO : documenter syntaxe
	$texte_lie='';
	foreach($tables_installees as $chose => $m) {
		$chaine1='un';
		$chaine2=substr($chose,0,-1);
		if ($chose=='syndic') $chaine2='site';
		elseif ($chose=='breve') $chaine1='une';

		if (($nb[$chose] = intval($nb[$chose])) == 1) {
			$texte_lie .= _T('info_'.$chaine1.'_'.$chaine2)." ";
		} else if ($nb[$chose] > 1) {
			$texte_lie .= _T('info_nombre_'.$chaine2.'s', array('nb_'.$chaine2.'s' => intval($nb[$chose]))) ." ";
		}
	}
///////////////////

	return debut_boite_info(true)
	. "<div class='serif'>"
	. _T('info_delet_mots_cles', array('titre_mot' => $titre_mot, 'type_mot' => $type_mot, 'texte_lie' => $texte_lie))
	. "<p style='text-align: right'>"
	. generer_supprimer_mot($id_mot, $son_groupe, ("<b>" . _T('item_oui') . "</b>"), $total)
	. "<br />\n"
	.  _T('info_oui_suppression_mot_cle')
	. '</p>'
	  /* troublant. A refaire avec une visibility
	 . "<li><b><a href='"
	. generer_url_ecrire("mots_tous")
	. "#editer_mot-$son_groupe"
	. "'>"
	. _T('item_non')
	. "</a>,</b> "
	. _T('info_non_suppression_mot_cle')
	. "</ul>" */
	. "</div>"
	. fin_boite_info(true);
}
?>
